Index: kernel/generic/src/debug/stacktrace.c
===================================================================
--- kernel/generic/src/debug/stacktrace.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/debug/stacktrace.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -39,4 +39,6 @@
 #include <stdio.h>
 
+#include <debug/line.h>
+
 #define STACK_FRAMES_MAX  20
 
@@ -44,6 +46,5 @@
 {
 	int cnt = 0;
-	const char *symbol;
-	uintptr_t offset;
+
 	uintptr_t fp;
 	uintptr_t pc;
@@ -51,11 +52,36 @@
 	while ((cnt++ < STACK_FRAMES_MAX) &&
 	    (ops->stack_trace_context_validate(ctx))) {
+
+		const char *symbol = NULL;
+		uintptr_t symbol_addr = 0;
+		const char *file_name = NULL;
+		const char *dir_name = NULL;
+		int line = 0;
+		int column = 0;
+
+		/*
+		 * If this isn't the first frame, move pc back by one byte to read the
+		 * position of the call instruction, not the return address.
+		 */
+		pc = cnt == 1 ? ctx->pc : ctx->pc - 1;
+
 		if (ops->symbol_resolve &&
-		    ops->symbol_resolve(ctx->pc, &symbol, &offset)) {
-			if (offset)
-				printf("%p: %s()+%p\n", (void *) ctx->fp,
-				    symbol, (void *) offset);
-			else
-				printf("%p: %s()\n", (void *) ctx->fp, symbol);
+		    ops->symbol_resolve(pc, 0, &symbol, &symbol_addr, &file_name, &dir_name, &line, &column)) {
+
+			if (symbol == NULL)
+				symbol = "<unknown>";
+
+			if (file_name == NULL && line == 0) {
+				printf("%p: %24s()+%zu\n", (void *) ctx->fp, symbol, ctx->pc - symbol_addr);
+			} else {
+				if (file_name == NULL)
+					file_name = "<unknown>";
+				if (dir_name == NULL)
+					dir_name = "<unknown>";
+
+				printf("%p: %20s()+%zu\t %s/%s:%d:%d\n",
+				    (void *) ctx->fp, symbol, ctx->pc - symbol_addr,
+				    dir_name, file_name, line, column);
+			}
 		} else
 			printf("%p: %p()\n", (void *) ctx->fp, (void *) ctx->pc);
@@ -104,7 +130,30 @@
 
 static bool
-kernel_symbol_resolve(uintptr_t addr, const char **sp, uintptr_t *op)
+resolve_kernel_address(uintptr_t addr, int op_index,
+    const char **symbol, uintptr_t *symbol_addr,
+    const char **filename, const char **dirname,
+    int *line, int *column)
 {
-	return (symtab_name_lookup(addr, sp, op) == 0);
+	*symbol_addr = 0;
+	*symbol = symtab_name_lookup(addr, symbol_addr, &kernel_sections);
+
+	return debug_line_get_address_info(&kernel_sections, addr, op_index, filename, dirname, line, column) || *symbol_addr != 0;
+}
+
+static bool
+resolve_uspace_address(uintptr_t addr, int op_index,
+    const char **symbol, uintptr_t *symbol_addr,
+    const char **filename, const char **dirname,
+    int *line, int *column)
+{
+	if (TASK->debug_sections == NULL)
+		return false;
+
+	debug_sections_t *scs = TASK->debug_sections;
+
+	*symbol_addr = 0;
+	*symbol = symtab_name_lookup(addr, symbol_addr, scs);
+
+	return debug_line_get_address_info(scs, addr, op_index, filename, dirname, line, column) || *symbol_addr != 0;
 }
 
@@ -113,5 +162,5 @@
 	.frame_pointer_prev = kernel_frame_pointer_prev,
 	.return_address_get = kernel_return_address_get,
-	.symbol_resolve = kernel_symbol_resolve
+	.symbol_resolve = resolve_kernel_address,
 };
 
@@ -120,5 +169,5 @@
 	.frame_pointer_prev = uspace_frame_pointer_prev,
 	.return_address_get = uspace_return_address_get,
-	.symbol_resolve = NULL
+	.symbol_resolve = resolve_uspace_address,
 };
 
Index: kernel/generic/src/debug/symtab.c
===================================================================
--- kernel/generic/src/debug/symtab.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/debug/symtab.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -36,47 +36,86 @@
  */
 
+#include <abi/elf.h>
+#include <byteorder.h>
+#include <console/prompt.h>
+#include <debug/sections.h>
+#include <errno.h>
+#include <proc/task.h>
+#include <stdio.h>
+#include <str.h>
 #include <symtab.h>
-#include <byteorder.h>
-#include <str.h>
-#include <stdio.h>
 #include <typedefs.h>
-#include <errno.h>
-#include <console/prompt.h>
-
-/** Get name of a symbol that seems most likely to correspond to address.
- *
- * @param addr   Address.
- * @param name   Place to store pointer to the symbol name.
- * @param offset Place to store offset from the symbol address.
- *
- * @return Zero on success or an error code, ENOENT if not found,
- *         ENOTSUP if symbol table not available.
- *
- */
-errno_t symtab_name_lookup(uintptr_t addr, const char **name, uintptr_t *offset)
-{
-#ifdef CONFIG_SYMTAB
-	size_t i;
-
-	for (i = 1; symbol_table[i].address_le; i++) {
-		if (addr < uint64_t_le2host(symbol_table[i].address_le))
+
+static inline const char *symtab_entry_name(debug_sections_t *scs, int entry)
+{
+	size_t index = scs->symtab[entry].st_name;
+
+	if (index >= scs->strtab_size)
+		return NULL;
+
+	return scs->strtab + index;
+}
+
+static inline size_t symtab_next(debug_sections_t *scs, size_t i)
+{
+	size_t symtab_len = scs->symtab_size / sizeof(elf_symbol_t);
+
+	for (; i < symtab_len; i++) {
+		const char *name = symtab_entry_name(scs, i);
+		int st_bind = elf_st_bind(scs->symtab[i].st_info);
+		int st_type = elf_st_type(scs->symtab[i].st_info);
+
+		if (st_bind == STB_LOCAL)
+			continue;
+
+		if (name == NULL || *name == '\0')
+			continue;
+
+		if (st_type == STT_FUNC || st_type == STT_OBJECT)
 			break;
 	}
 
-	if (addr >= uint64_t_le2host(symbol_table[i - 1].address_le)) {
-		*name = symbol_table[i - 1].symbol_name;
-		if (offset)
-			*offset = addr -
-			    uint64_t_le2host(symbol_table[i - 1].address_le);
-		return EOK;
-	}
-
-	*name = NULL;
-	return ENOENT;
-
-#else
-	*name = NULL;
-	return ENOTSUP;
-#endif
+	return i;
+}
+
+const char *symtab_name_lookup(uintptr_t addr, uintptr_t *symbol_addr, debug_sections_t *scs)
+{
+	const elf_symbol_t *symtab = scs->symtab;
+	size_t symtab_len = scs->symtab_size / sizeof(elf_symbol_t);
+	const char *strtab = scs->strtab;
+	size_t strtab_size = scs->strtab_size;
+
+	if (symtab == NULL || strtab == NULL)
+		return NULL;
+
+	uintptr_t closest_symbol_addr = 0;
+	uintptr_t closest_symbol_name = 0;
+
+	for (size_t i = symtab_next(scs, 0); i < symtab_len; i = symtab_next(scs, i + 1)) {
+		if (symtab[i].st_value > addr)
+			continue;
+
+		if (symtab[i].st_value + symtab[i].st_size > addr) {
+			closest_symbol_addr = symtab[i].st_value;
+			closest_symbol_name = symtab[i].st_name;
+			break;
+		}
+
+		if (symtab[i].st_value > closest_symbol_addr) {
+			closest_symbol_addr = symtab[i].st_value;
+			closest_symbol_name = symtab[i].st_name;
+		}
+	}
+
+	if (closest_symbol_addr == 0)
+		return NULL;
+
+	if (symbol_addr)
+		*symbol_addr = closest_symbol_addr;
+
+	if (closest_symbol_name >= strtab_size)
+		return NULL;
+
+	return strtab + closest_symbol_name;
 }
 
@@ -95,53 +134,9 @@
 const char *symtab_fmt_name_lookup(uintptr_t addr)
 {
-	const char *name;
-	errno_t rc = symtab_name_lookup(addr, &name, NULL);
-
-	switch (rc) {
-	case EOK:
-		return name;
-	case ENOENT:
-		return "unknown";
-	default:
-		return "N/A";
-	}
-}
-
-#ifdef CONFIG_SYMTAB
-
-/** Find symbols that match the parameter forward and print them.
- *
- * @param name     Search string
- * @param startpos Starting position, changes to found position
- *
- * @return Pointer to the part of string that should be completed or NULL.
- *
- */
-static const char *symtab_search_one(const char *name, size_t *startpos)
-{
-	size_t namelen = str_length(name);
-
-	size_t pos;
-	for (pos = *startpos; symbol_table[pos].address_le; pos++) {
-		const char *curname = symbol_table[pos].symbol_name;
-
-		/* Find a ':' in curname */
-		const char *colon = str_chr(curname, ':');
-		if (colon == NULL)
-			continue;
-
-		if (str_length(curname) < namelen)
-			continue;
-
-		if (str_lcmp(name, curname, namelen) == 0) {
-			*startpos = pos;
-			return (curname + str_lsize(curname, namelen));
-		}
-	}
-
-	return NULL;
-}
-
-#endif
+	const char *name = symtab_name_lookup(addr, NULL, &kernel_sections);
+	if (name == NULL)
+		name = "<unknown>";
+	return name;
+}
 
 /** Return address that corresponds to the entry.
@@ -152,34 +147,20 @@
  * @param addr Place to store symbol address
  *
- * @return Zero on success, ENOENT - not found, EOVERFLOW - duplicate
- *         symbol, ENOTSUP - no symbol information available.
+ * @return Zero on success, ENOENT - not found
  *
  */
 errno_t symtab_addr_lookup(const char *name, uintptr_t *addr)
 {
-#ifdef CONFIG_SYMTAB
-	size_t found = 0;
-	size_t pos = 0;
-	const char *hint;
-
-	while ((hint = symtab_search_one(name, &pos))) {
-		if (str_length(hint) == 0) {
-			*addr = uint64_t_le2host(symbol_table[pos].address_le);
-			found++;
-		}
-		pos++;
-	}
-
-	if (found > 1)
-		return EOVERFLOW;
-
-	if (found < 1)
-		return ENOENT;
-
-	return EOK;
-
-#else
-	return ENOTSUP;
-#endif
+	debug_sections_t *scs = &kernel_sections;
+	size_t symtab_len = scs->symtab_size / sizeof(elf_symbol_t);
+
+	for (size_t i = symtab_next(scs, 0); i < symtab_len; i = symtab_next(scs, i + 1)) {
+		if (str_cmp(name, symtab_entry_name(scs, i)) == 0) {
+			*addr = scs->symtab[i].st_value;
+			return EOK;
+		}
+	}
+
+	return ENOENT;
 }
 
@@ -187,44 +168,41 @@
 void symtab_print_search(const char *name)
 {
-#ifdef CONFIG_SYMTAB
-	size_t pos = 0;
-	while (symtab_search_one(name, &pos)) {
-		uintptr_t addr = uint64_t_le2host(symbol_table[pos].address_le);
-		char *realname = symbol_table[pos].symbol_name;
-		printf("%p: %s\n", (void *) addr, realname);
-		pos++;
-	}
-
-#else
-	printf("No symbol information available.\n");
-#endif
+	debug_sections_t *scs = &kernel_sections;
+	size_t symtab_len = scs->symtab_size / sizeof(elf_symbol_t);
+
+	if (scs->symtab == NULL || scs->strtab == NULL) {
+		printf("No symbol information available.\n");
+		return;
+	}
+
+	size_t namelen = str_length(name);
+
+	for (size_t i = symtab_next(scs, 0); i < symtab_len; i = symtab_next(scs, i + 1)) {
+		const char *n = symtab_entry_name(scs, i);
+
+		if (str_lcmp(name, n, namelen) == 0) {
+			printf("%p: %s\n", (void *) scs->symtab[i].st_value, n);
+		}
+	}
 }
 
 /** Symtab completion enum, see kernel/generic/include/kconsole.h */
-const char *symtab_hints_enum(const char *input, const char **help,
-    void **ctx)
-{
-#ifdef CONFIG_SYMTAB
+const char *symtab_hints_enum(const char *input, const char **help, void **ctx)
+{
+	debug_sections_t *scs = &kernel_sections;
+	size_t symtab_len = scs->symtab_size / sizeof(elf_symbol_t);
+
+	if (scs->symtab == NULL || scs->strtab == NULL)
+		return NULL;
+
+	if (help)
+		*help = NULL;
+
 	size_t len = str_length(input);
-	struct symtab_entry **entry = (struct symtab_entry **)ctx;
-
-	if (*entry == NULL)
-		*entry = symbol_table;
-
-	for (; (*entry)->address_le; (*entry)++) {
-		const char *curname = (*entry)->symbol_name;
-
-		/* Find a ':' in curname */
-		const char *colon = str_chr(curname, ':');
-		if (colon == NULL)
-			continue;
-
-		if (str_length(curname) < len)
-			continue;
+	for (size_t i = symtab_next(scs, (size_t) *ctx); i < symtab_len; i = symtab_next(scs, i + 1)) {
+		const char *curname = symtab_entry_name(scs, i);
 
 		if (str_lcmp(input, curname, len) == 0) {
-			(*entry)++;
-			if (help)
-				*help = NULL;
+			*ctx = (void *) (i + 1);
 			return (curname + str_lsize(curname, len));
 		}
@@ -232,8 +210,4 @@
 
 	return NULL;
-
-#else
-	return NULL;
-#endif
 }
 
Index: kernel/generic/src/debug/util.c
===================================================================
--- kernel/generic/src/debug/util.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ kernel/generic/src/debug/util.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,271 @@
+/*
+ * Copyright (c) 2023 Jiří Zárevúcky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include "util.h"
+
+#include <stdio.h>
+#include <debug/sections.h>
+#include <debug/names.h>
+
+bool skip_data(unsigned form, const uint8_t **const data,
+    const uint8_t *data_end, unsigned width)
+{
+	// Skip data we don't care about reading.
+
+	size_t len;
+
+	switch (form) {
+	case DW_FORM_string:
+		skip_string(data, data_end);
+		break;
+
+	case DW_FORM_strp:
+	case DW_FORM_line_strp:
+	case DW_FORM_strp_sup:
+	case DW_FORM_sec_offset:
+		safe_increment(data, data_end, width);
+		break;
+
+	case DW_FORM_strx:
+	case DW_FORM_sdata:
+	case DW_FORM_udata:
+		skip_leb128(data, data_end);
+		break;
+
+	case DW_FORM_strx1:
+	case DW_FORM_data1:
+	case DW_FORM_flag:
+		safe_increment(data, data_end, 1);
+		break;
+
+	case DW_FORM_strx2:
+	case DW_FORM_data2:
+		safe_increment(data, data_end, 2);
+		break;
+
+	case DW_FORM_strx3:
+		safe_increment(data, data_end, 3);
+		break;
+
+	case DW_FORM_strx4:
+	case DW_FORM_data4:
+		safe_increment(data, data_end, 4);
+		break;
+
+	case DW_FORM_data8:
+		safe_increment(data, data_end, 8);
+		break;
+
+	case DW_FORM_data16:
+		safe_increment(data, data_end, 16);
+		break;
+
+	case DW_FORM_block:
+		len = read_uleb128(data, data_end);
+		safe_increment(data, data_end, len);
+		break;
+
+	case DW_FORM_block1:
+		len = read_byte(data, data_end);
+		safe_increment(data, data_end, len);
+		break;
+
+	case DW_FORM_block2:
+		len = read_uint16(data, data_end);
+		safe_increment(data, data_end, len);
+		break;
+
+	case DW_FORM_block4:
+		len = read_uint32(data, data_end);
+		safe_increment(data, data_end, len);
+		break;
+
+	default:
+		// Unknown FORM.
+		*data = data_end;
+		return false;
+	}
+
+	return true;
+}
+
+void print_format(const char *name, const uint8_t *format, const uint8_t *format_end)
+{
+	DEBUGF("%s: ", name);
+
+	while (format < format_end) {
+		uint64_t lnct = read_uleb128(&format, format_end);
+		uint64_t form = read_uleb128(&format, format_end);
+
+		const char *fname = dw_form_name(form);
+
+		if (fname)
+			DEBUGF("%s:%s, ", dw_lnct_name(lnct), fname);
+		else
+			DEBUGF("%s:unknown DW_FORM_(%" PRIu64 "), ", dw_lnct_name(lnct), form);
+	}
+
+	DEBUGF("\n");
+}
+
+void print_formatted_list(debug_sections_t *scs, const char *name,
+    const uint8_t *data, const uint8_t *const data_end,
+    const uint8_t *format, const uint8_t *format_end,
+    unsigned width)
+{
+	DEBUGF("%s: ", name);
+
+	while (data < data_end) {
+		const uint8_t *old_data = data;
+		const uint8_t *format_ptr = format;
+
+		while (format_ptr < format_end) {
+			uint64_t lnct = read_uleb128(&format_ptr, format_end);
+			uint64_t form = read_uleb128(&format_ptr, format_end);
+
+			DEBUGF("%s:%s:", dw_lnct_name(lnct), dw_form_name(form));
+			print_formed_data(scs, form, &data, data_end, width);
+			DEBUGF("\n");
+		}
+
+		if (data <= old_data)
+			break;
+	}
+
+	DEBUGF("\n");
+}
+
+void print_block(const uint8_t **const data,
+    const uint8_t *data_end, unsigned bytes)
+{
+	while (bytes > 0 && *data < data_end) {
+		DEBUGF("%02x ", **data);
+		(*data)++;
+		bytes--;
+	}
+}
+
+void print_formed_data(debug_sections_t *scs, unsigned form, const uint8_t **const data,
+    const uint8_t *data_end, unsigned width)
+{
+	size_t len;
+	uint64_t offset;
+
+	switch (form) {
+	case DW_FORM_string:
+		DEBUGF("\"%s\"", read_string(data, data_end));
+		break;
+
+	case DW_FORM_strp:
+	case DW_FORM_strp_sup:
+		offset = read_uint(data, data_end, width);
+		if (offset >= scs->debug_str_size)
+			DEBUGF("<out of range>");
+		else
+			DEBUGF("\"%s\"", scs->debug_str + offset);
+		break;
+
+	case DW_FORM_line_strp:
+		offset = read_uint(data, data_end, width);
+		if (offset >= scs->debug_line_str_size)
+			DEBUGF("<out of range>");
+		else
+			DEBUGF("\"%s\"", scs->debug_line_str + offset);
+		break;
+
+	case DW_FORM_sec_offset:
+		if (width == 4)
+			DEBUGF("0x%08" PRIx64, read_uint(data, data_end, width));
+		else
+			DEBUGF("0x%016" PRIx64, read_uint(data, data_end, width));
+		break;
+
+	case DW_FORM_strx:
+	case DW_FORM_udata:
+		DEBUGF("%" PRIu64, read_uleb128(data, data_end));
+		break;
+
+	case DW_FORM_sdata:
+		DEBUGF("%" PRId64, read_sleb128(data, data_end));
+		break;
+
+	case DW_FORM_strx1:
+	case DW_FORM_data1:
+	case DW_FORM_flag:
+		DEBUGF("%u", read_byte(data, data_end));
+		break;
+
+	case DW_FORM_strx2:
+	case DW_FORM_data2:
+		DEBUGF("%u", read_uint16(data, data_end));
+		break;
+
+	case DW_FORM_strx3:
+		DEBUGF("%u", read_uint24(data, data_end));
+		break;
+
+	case DW_FORM_strx4:
+	case DW_FORM_data4:
+		DEBUGF("%u", read_uint32(data, data_end));
+		break;
+
+	case DW_FORM_data8:
+		DEBUGF("%" PRIu64, read_uint64(data, data_end));
+		break;
+
+	case DW_FORM_data16:
+		uint64_t data1 = read_uint64(data, data_end);
+		uint64_t data2 = read_uint64(data, data_end);
+		DEBUGF("0x%016" PRIx64 "%016" PRIx64, data2, data1);
+		break;
+
+	case DW_FORM_block:
+		len = read_uleb128(data, data_end);
+		print_block(data, data_end, len);
+		break;
+
+	case DW_FORM_block1:
+		len = read_byte(data, data_end);
+		print_block(data, data_end, len);
+		break;
+
+	case DW_FORM_block2:
+		len = read_uint16(data, data_end);
+		print_block(data, data_end, len);
+		break;
+
+	case DW_FORM_block4:
+		len = read_uint32(data, data_end);
+		print_block(data, data_end, len);
+		break;
+
+	default:
+		DEBUGF("unexpected form");
+		*data = data_end;
+	}
+}
Index: kernel/generic/src/debug/util.h
===================================================================
--- kernel/generic/src/debug/util.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ kernel/generic/src/debug/util.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,268 @@
+/*
+ * Copyright (c) 2023 Jiří Zárevúcky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef DEBUG_UTIL_H_
+#define DEBUG_UTIL_H_
+
+#include <assert.h>
+#include <stdint.h>
+#include <debug/constants.h>
+#include <debug/sections.h>
+#include <debug.h>
+
+#define DEBUGF dummy_printf
+
+extern bool skip_data(unsigned, const uint8_t **const, const uint8_t *, unsigned);
+extern void print_format(const char *, const uint8_t *, const uint8_t *);
+extern void print_formatted_list(debug_sections_t *, const char *,
+    const uint8_t *, const uint8_t *, const uint8_t *, const uint8_t *, unsigned);
+
+extern void print_block(const uint8_t **, const uint8_t *, unsigned);
+extern void print_formed_data(debug_sections_t *scs, unsigned, const uint8_t **const, const uint8_t *, unsigned);
+
+static inline uint8_t read_byte(const uint8_t **data, const uint8_t *data_end)
+{
+	if (*data >= data_end) {
+		return 0;
+	} else {
+		return *((*data)++);
+	}
+}
+
+/* Casting to these structures allows us to read unaligned integers safely. */
+struct u16 {
+	uint16_t val;
+} __attribute__((packed));
+
+struct u32 {
+	uint32_t val;
+} __attribute__((packed));
+
+struct u64 {
+	uint64_t val;
+} __attribute__((packed));
+
+static inline uint16_t read_uint16(const uint8_t **data, const uint8_t *data_end)
+{
+	if (*data + 2 > data_end) {
+		/* Safe exit path for malformed input. */
+		*data = data_end;
+		return 0;
+	}
+
+	uint16_t v = ((struct u16 *) *data)->val;
+	*data += 2;
+	return v;
+}
+
+static inline uint32_t read_uint24(const uint8_t **data, const uint8_t *data_end)
+{
+	if (*data + 3 > data_end) {
+		/* Safe exit path for malformed input. */
+		*data = data_end;
+		return 0;
+	}
+
+#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
+	uint32_t v = (*data)[0] | (*data)[1] << 8 | (*data)[2] << 16;
+#else
+	uint32_t v = (*data)[2] | (*data)[1] << 8 | (*data)[0] << 16;
+#endif
+
+	*data += 3;
+	return v;
+}
+
+static inline uint32_t read_uint32(const uint8_t **data, const uint8_t *data_end)
+{
+	if (*data + 4 > data_end) {
+		/* Safe exit path for malformed input. */
+		*data = data_end;
+		return 0;
+	}
+
+	uint32_t v = ((struct u32 *) *data)->val;
+	*data += 4;
+	return v;
+}
+
+static inline uint64_t read_uint64(const uint8_t **data, const uint8_t *data_end)
+{
+	if (*data + 8 > data_end) {
+		/* Safe exit path for malformed input. */
+		*data = data_end;
+		return 0;
+	}
+
+	uint64_t v = ((struct u64 *) *data)->val;
+	*data += 8;
+	return v;
+}
+
+static inline uint64_t read_uint(const uint8_t **data, const uint8_t *data_end, unsigned bytes)
+{
+	switch (bytes) {
+	case 1:
+		return read_byte(data, data_end);
+	case 2:
+		return read_uint16(data, data_end);
+	case 4:
+		return read_uint32(data, data_end);
+	case 8:
+		return read_uint64(data, data_end);
+	default:
+		panic("unimplemented");
+	}
+}
+
+static inline uint64_t read_uleb128(const uint8_t **data, const uint8_t *data_end)
+{
+	uint64_t result = 0;
+	unsigned shift = 0;
+
+	while (*data < data_end) {
+		uint8_t byte = *((*data)++);
+		result |= (byte & 0x7f) << shift;
+		shift += 7;
+
+		if ((byte & 0x80) == 0)
+			break;
+	}
+
+	return result;
+}
+
+static inline int64_t read_sleb128(const uint8_t **data, const uint8_t *data_end)
+{
+	uint64_t result = 0;
+	unsigned shift = 0;
+
+	while (*data < data_end) {
+		uint8_t byte = *((*data)++);
+		result |= (byte & 0x7f) << shift;
+		shift += 7;
+
+		if ((byte & 0x80) == 0) {
+			if (shift < 64 && (byte & 0x40) != 0) {
+				/* sign extend */
+				result |= -(1 << shift);
+			}
+			break;
+		}
+	}
+
+	return (int64_t) result;
+}
+
+static inline void skip_leb128(const uint8_t **data, const uint8_t *data_end)
+{
+	while (*data < data_end) {
+		uint8_t byte = *((*data)++);
+		if ((byte & 0x80) == 0)
+			break;
+	}
+}
+
+static inline uint64_t read_initial_length(const uint8_t **data, const uint8_t *data_end, unsigned *width)
+{
+	uint32_t initial = read_uint32(data, data_end);
+	if (initial == 0xffffffffu) {
+		*width = 8;
+		return read_uint64(data, data_end);
+	} else {
+		*width = 4;
+		return initial;
+	}
+}
+
+static inline const char *read_string(const uint8_t **data, const uint8_t *data_end)
+{
+	const char *start = (const char *) *data;
+
+	// NUL-terminated string.
+	while (*data < data_end && **data != 0)
+		(*data)++;
+
+	if (*data < data_end) {
+		// Skip the terminating zero.
+		(*data)++;
+		return start;
+	} else {
+		// No terminating zero, we can't use this.
+		return NULL;
+	}
+}
+
+static inline void skip_string(const uint8_t **data, const uint8_t *data_end)
+{
+	(void) read_string(data, data_end);
+}
+
+static inline void safe_increment(const uint8_t **data,
+    const uint8_t *data_end, ptrdiff_t increment)
+{
+	assert(data_end >= *data);
+
+	if (increment >= data_end - *data) {
+		*data = data_end;
+	} else {
+		(*data) += increment;
+	}
+}
+
+static inline void skip_format(const uint8_t **data, const uint8_t *const data_end,
+    unsigned count)
+{
+	for (unsigned i = 0; i < count; i++) {
+		(void) read_uleb128(data, data_end);
+		(void) read_uleb128(data, data_end);
+	}
+}
+
+static inline void skip_formatted_entry(const uint8_t **data, const uint8_t *const data_end,
+    const uint8_t *format, const uint8_t *format_end, unsigned width)
+{
+	while (format < format_end) {
+		/* Ignore content type code */
+		(void) read_uleb128(&format, format_end);
+
+		uint64_t form = read_uleb128(&format, format_end);
+		skip_data(form, data, data_end, width);
+	}
+}
+
+static inline void skip_formatted_list(const uint8_t **data, const uint8_t *const data_end,
+    unsigned count,	const uint8_t *format, const uint8_t *format_end,
+    unsigned width)
+{
+	for (unsigned i = 0; i < count; i++) {
+		skip_formatted_entry(data, data_end, format, format_end, width);
+	}
+}
+
+#endif /* DEBUG_UTIL_H_ */
Index: kernel/generic/src/interrupt/interrupt.c
===================================================================
--- kernel/generic/src/interrupt/interrupt.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/interrupt/interrupt.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -58,4 +58,11 @@
 #include <trace.h>
 
+/*
+ * If IVT_ITEMS is zero (e.g. for special/abs32le) we hide completely any
+ * access to the exception table array and panic if the function is called
+ * at all. It also silences (correct) compiler warnings about possible
+ * out-of-bound array access.
+ */
+
 exc_table_t exc_table[IVT_ITEMS];
 IRQ_SPINLOCK_INITIALIZE(exctbl_lock);
@@ -77,5 +84,4 @@
 #if (IVT_ITEMS > 0)
 	assert(n < IVT_ITEMS);
-#endif
 
 	irq_spinlock_lock(&exctbl_lock, true);
@@ -91,4 +97,7 @@
 
 	return old;
+#else
+	panic("No space for any exception handler, cannot register.");
+#endif
 }
 
@@ -103,21 +112,15 @@
 #if (IVT_ITEMS > 0)
 	assert(n < IVT_ITEMS);
-#endif
 
 	/* Account user cycles */
-	if (THREAD) {
-		irq_spinlock_lock(&THREAD->lock, false);
+	if (THREAD)
 		thread_update_accounting(true);
-		irq_spinlock_unlock(&THREAD->lock, false);
-	}
 
 	/* Account CPU usage if it woke up from sleep */
-	if (CPU && CPU->idle) {
-		irq_spinlock_lock(&CPU->lock, false);
+	if (CPU && CPU_LOCAL->idle) {
 		uint64_t now = get_cycle();
-		CPU->idle_cycles += now - CPU->last_cycle;
-		CPU->last_cycle = now;
-		CPU->idle = false;
-		irq_spinlock_unlock(&CPU->lock, false);
+		atomic_time_increment(&CPU->idle_cycles, now - CPU_LOCAL->last_cycle);
+		CPU_LOCAL->last_cycle = now;
+		CPU_LOCAL->idle = false;
 	}
 
@@ -149,9 +152,9 @@
 
 	/* Do not charge THREAD for exception cycles */
-	if (THREAD) {
-		irq_spinlock_lock(&THREAD->lock, false);
+	if (THREAD)
 		THREAD->last_cycle = end_cycle;
-		irq_spinlock_unlock(&THREAD->lock, false);
-	}
+#else
+	panic("No space for any exception handler, yet we want to handle some exception.");
+#endif
 }
 
Index: kernel/generic/src/ipc/event.c
===================================================================
--- kernel/generic/src/ipc/event.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/ipc/event.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -169,6 +169,5 @@
 				    true);
 
-				waitq_wakeup(&event->answerbox->wq,
-				    WAKEUP_FIRST);
+				waitq_wake_one(&event->answerbox->wq);
 
 				if (mask)
Index: kernel/generic/src/ipc/ipc.c
===================================================================
--- kernel/generic/src/ipc/ipc.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/ipc/ipc.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -54,5 +54,5 @@
 #include <arch.h>
 #include <proc/task.h>
-#include <mem.h>
+#include <memw.h>
 #include <stdio.h>
 #include <console/console.h>
@@ -326,5 +326,5 @@
 		irq_spinlock_unlock(&callerbox->lock, true);
 
-	waitq_wakeup(&callerbox->wq, WAKEUP_FIRST);
+	waitq_wake_one(&callerbox->wq);
 }
 
@@ -416,5 +416,5 @@
 	irq_spinlock_unlock(&box->lock, true);
 
-	waitq_wakeup(&box->wq, WAKEUP_FIRST);
+	waitq_wake_one(&box->wq);
 }
 
@@ -555,5 +555,5 @@
 	errno_t rc;
 
-	rc = waitq_sleep_timeout(&box->wq, usec, flags, NULL);
+	rc = _waitq_sleep_timeout(&box->wq, usec, flags);
 	if (rc != EOK)
 		return rc;
@@ -967,12 +967,7 @@
 void ipc_print_task(task_id_t taskid)
 {
-	irq_spinlock_lock(&tasks_lock, true);
 	task_t *task = task_find_by_id(taskid);
-	if (!task) {
-		irq_spinlock_unlock(&tasks_lock, true);
+	if (!task)
 		return;
-	}
-	task_hold(task);
-	irq_spinlock_unlock(&tasks_lock, true);
 
 	printf("[phone cap] [calls] [state\n");
Index: kernel/generic/src/ipc/irq.c
===================================================================
--- kernel/generic/src/ipc/irq.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/ipc/irq.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -429,5 +429,5 @@
 	irq_spinlock_unlock(&irq->notif_cfg.answerbox->irq_lock, false);
 
-	waitq_wakeup(&irq->notif_cfg.answerbox->wq, WAKEUP_FIRST);
+	waitq_wake_one(&irq->notif_cfg.answerbox->wq);
 }
 
